//
//  AppDelegate.swift
//  Notifications
//
//  Created by Holger Hinzberg on 12.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool
    {
        // Für Benachrichtigungen registrieren
        let notificationSettings = UIUserNotificationSettings(forTypes: [.Alert, .Badge, .Sound], categories: nil)
        UIApplication.sharedApplication().registerUserNotificationSettings(notificationSettings)
        
        // Eine Benachrichtigungen beim
        //Programmstart entgegennehmen, falls vorhanden
        if let note:UILocalNotification
            = launchOptions?[
                UIApplicationLaunchOptionsLocalNotificationKey]
                as? UILocalNotification
        {
            print(note.alertBody)
        }
        
        return true
    }

    // Eigenschaft um die Auswahl zu speichern
    var didRegisterForNotifcations:Bool?
    
    func application(application: UIApplication,
        didRegisterUserNotificationSettings
        notificationSettings: UIUserNotificationSettings)
    {
        if notificationSettings.types == UIUserNotificationType.None
        {
            self.didRegisterForNotifcations = false
            print("Benachrichtigungen nicht erlaubt")
        }
        else
        {
            self.didRegisterForNotifcations = true
            print("Benachrichtigungen erlaubt")
        }
    }
    
    
    func application(application: UIApplication,
        didReceiveLocalNotification
        notification: UILocalNotification)
    {
        // Den eigenen Programnamen ermitteln
        let bundle = NSBundle.mainBundle()
        let info = bundle.infoDictionary;
        let bundleKey = kCFBundleNameKey as String
        let appName = info?[bundleKey] as? String
        
        // Einen Alert View mit der Benachrichtigung anzeigen
        let alert = UIAlertController()
        alert.title = appName
        alert.message = notification.alertBody
        let action = UIAlertAction(title: "OK", style: .Default, handler:nil)
        alert.addAction(action)
        
        self.window?.rootViewController?
            .presentViewController(alert, animated: true, completion: nil)
    }
    
    func applicationWillResignActive(application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}

