//
//  ViewController.swift
//  Notifications
//
//  Created by Holger Hinzberg on 12.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction func notificationButtonTouched(sender: AnyObject)
    {
        let localNote = UILocalNotification()
        // Der anzuzeigende Text
        localNote.alertBody
            = "Ein Termin ist fällig"
        
        // Die Überschrift der Nachricht
        localNote.alertTitle
          = "Wichtige Mitteilung"
        
        // Die Zeitzone
        localNote.timeZone
            = NSTimeZone.defaultTimeZone()
        
        // Zusätzliche Konfiguration:
        // Ein akustisches Signal ausgeben
        localNote.soundName = UILocalNotificationDefaultSoundName
        // Den Badge-Wert erhöhen
        localNote.applicationIconBadgeNumber =
            UIApplication.sharedApplication()
                .applicationIconBadgeNumber + 1
        
        // Die Benachrichtigung jede Stunde wiederholen
        localNote.repeatInterval = NSCalendarUnit.Hour
        
        // Zusätzliche Informationen mit dem userInfo übertragen
        let info = ["ID":"AB12", "Event":"Gartenparty", "Place":"Bei Georg"]
        localNote.userInfo = info
        
        
        // Der Zeitpunkt, an dem die Nachricht angezeigt werden soll
        localNote.fireDate
          = NSDate(timeIntervalSinceNow: 2)
        
        // Die Nachricht an das Betriebssystem übergeben
        let app = UIApplication.sharedApplication()
        app.scheduleLocalNotification(localNote)
        
        /*
        // Sämtliche Benachrichtigungen der App holen
        let localNotifications = app.scheduledLocalNotifications
        
        // Mit einer Schleife alle Benachrichtigungen kontrollieren
        if let localNotes = localNotifications
        {
            // Den zum Schlüssel "ID" gehörenden Wert
            // im Dictionary userInfo suchen
            for note in localNotes
            {
                if let id = note.userInfo?["ID"] as? String
                {
                    if id == "AB12"
                    {
                        app.cancelLocalNotification(note)
                        break
                    }
                }
            }
        }
        */
        
        // Einen Badge manuell setzen
        // let app = UIApplication.sharedApplication()
        // app.applicationIconBadgeNumber = 99
    }
}

